      SUBROUTINE ALLZERO(STANOW,RTNOW,N,NOBS,CNT,IFLAG,LINEAR, NDIST,STRNOW,ALT)
C
C  THIS SUBROUTINE CHECKS TO SEE IF ALL COUNTS WERE ZERO ON A ROUTE.
C  IF SO, IT KICKS THE DATA OUT TO AN ALL-ZERO FILE. IT ALSO KICKS OUT ALL SINGULAR MATRICES OR N<2  CALLED FROM THE MAIN PROGRAM

      PARAMETER (MYRS=200)
      DOUBLE PRECISION CNT(MYRS),DUMMY
      REAL STANOW
      INTEGER ALT,iflag



      IFLAG=1  !    SEPARATE OUT ROUTES WITH TOO MUCH DATA TO BE ANALYZED
      IF(N .GT. myrs .AND. NOBS .GT. 45) RETURN
      DUMMY=ALOG(0.5)

      IF(LINEAR .EQ. 1) DUMMY = 0.0
      IFLAG=1

      SUM=0.0  !   SET THE ROUTE TO ALL ZERO IF <1 YEAR HAS COUNTS >0
      DO I=1,N
        IF(CNT(I) .GT. (DUMMY+0.02d0)) THEN
          SUM=SUM+1.0
          IFLAG=0
        END IF
      END DO
      IF(IFLAG .NE. 0) THEN
         AA=0.0  !   NOW PRINT OUT THOSE ZERO ROUTES TO THE SLOPE FILE SO THEY CAN BE ADDED IN TO THE COUNTS.
         AA2=0.
         NA1=0
         IF(ALT.eq.3) WRITE(8,40) STANOW,RTNOW,STRNOW, AA,AA,AA,AA2,NA1
   40    FORMAT(1X,F6.0,1X,F5.0,1X,F4.0,2(1X,F13.8),1X,F13.6,20X,F9.2,1X,I2)
         RETURN

C        THESE NEXT LIMITS CHANGE WITH THE NUMBER OF YEARS!!!   NOW N MUST BE > NOBS+1
C        IF DISTURBANCE IS TO BE INCLUDED, SET NOBS TO NOBS+1.  DOES THIS CAUSE ERRORS?

      END IF
      IF(NDIST .EQ. 0) NOBS=NOBS+1
      IF(N .GT. (NOBS+1)) RETURN
      IFLAG=1

C  IF THE ROUTE WAS RUN AT LEAST 2 YEARS BY THE SAME OBSERVER,  SET FLAG=2.

      IF(N .GE. 2 .AND. N .GT. NOBS .AND. NDIST .NE. 0) THEN
         IFLAG=2
         if(n.gt.2) iflag=3
         RETURN
      END IF
      AA=0.0
      AA2=REAL(DEXP(CNT(1)))-0.5
      NA1=1
      IF(ALT.Eq.3) WRITE(8,40) STANOW,RTNOW,STRNOW, AA,AA,AA,AA2,NA1
      RETURN
      END
