      SUBROUTINE ANALIND(SLOPE,N,NCOL,DES,RESID,CNT)

C  THIS SUBROUTINE (ANALY) COMES UP WITH ESTIMATES OF THE RESIDUALS, WHICH THEN MUST BE BACK-TRANSFORMED

      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION DES(MYRS,MCOLS),CNT(MYRS),COVA(MCOLS,MCOLS),NEWCNT(MYRS),SLOPE,RESID(MYRS),XX,
     ,  XPR(MCOLS,MYRS),XPX(MCOLS,MCOLS), XPXINV(MCOLS,MCOLS), XPY(MYRS), BMAT(MYRS)
      integer n,ncol

C  FIRST, FIND THE NEW DEPENDENT VARIABLE

      XX=LOG(SLOPE)
      DO I=1,N
        NEWCNT(I)=CNT(I)-(XX*DES(I,2))
      END DO

C NOW FIND THE NEW X MATRIX

      DO I=3,NCOL
        DO J=1,N
          DES(J,I-1)=DES(J,I)
       END DO
      END DO
      NCOL=NCOL-1
      XPR=TRANSPOSE(DES)  ! CALL TRANS(N,NCOL,DES,XPR)  ! FIND THE X PRIME MATRIX
      CALL MATMLT(XPR,DES,XPX,NCOL,N,NCOL,MCOLS,MYRS,MCOLS)  !  FIND THE X PRIME-X MATRIX
      CALL INVERT(NCOL,XPX,XPXINV)  !   FIND THE X PRIME X INVERSE MATRIX
      CALL MATMLT(XPR,NEWCNT,XPY,NCOL,N,1,MCOLS,MYRS,1)  !   FIND THE X PRIME Y VECTOR
      CALL MATMLT(XPXINV,XPY,BMAT,NCOL,NCOL,1,MCOLS,MCOLS,1)  !  FIND THE B VECTOR (X'X)-1 (X'Y)
      IF(N.GT. 2) CALL VARCOV(N,NCOL,CNT,XPY,BMAT,XPXINV,COVA)  !  CALL THE SUBROUTINE TO GET THE VAR-COV MATRIX
      CALL MATMLT(DES,BMAT,RESID,N,NCOL,1,MYRS,MCOLS,1)  !   NOW FIND THE TRANSFORMED Y HAT MATRIX


      DO I=1,N   !   FIND THE RESIDUAL
        RESID(I)=NEWCNT(I)-RESID(I)
C       THESE ARE THE RESIDUALS.  NOW SUBT THEM FROM THE ORIGINAL COUNTS, (TO FIND THE PREDICTED VALUES), EXPONENTIATE THEM,
C       AND THEN FIND THE RESIDUAL ON THE CORRECT SCALE  STORE THAT VALUE
C       THIS IS NOW COMMENTED, AS I AM AVERAGING THEM ON THE LOG SCALE, THEN BACK-TRANSFORMING THE RESULTS LATER
C       RESID(I)=CNT(I)-RESID(I)
C       RESID(I)=EXP(RESID(I))-0.5
C       CNT(I)=EXP(CNT(I))-0.5
C       RESID(I)=CNT(I)-RESID(I)

C       NOTE THAT THE BELOW BACK-TRANSFORM IS NO LONGER USED.  FOR NOW, BACK-TRANSFORM IT BY EXPONENTIATIONS ADJUST SIGN, SO RESID ISN'T ALWAYS POSITIVE

C       NFLAG=0
C       IF(RESID(I).LT. 0.0) NFLAG=1
C       RESID(I)=DABS(RESID(I))
C       RESID(I)=EXP(RESID(I))
C       IF(NFLAG.EQ. 1) RESID(I)=-1.0*RESID(I)
      END DO
      RETURN
      END
