      SUBROUTINE ANALY(NOBS,N,NCOL,DES,OBS,CNT,BMAT,COVA,MARGM, VARMAR,WTXPX)
c         THIS SUBROUTINE (ANALY) COMES UP WITH ESTIMATES OF THE RESIDUALS, WHICH THEN MUST BE BACK-TRANSFORMED
      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION DES(MYRS,MCOLS),CNT(MYRS),XPR(MCOLS,MYRS),XPX(MCOLS,MCOLS),XPXINV(MCOLS,MCOLS),XPY(MYRS)
      DOUBLE PRECISION BMAT(MYRS), COVA(MCOLS,MCOLS),MARGM,VARMAR,WTXPX
      CHARACTER*5 OBS(MYRS)

      CALL SETCOLMN(NOBS,N,NCOL,DES,OBS)
      XPR=TRANSPOSE(DES)                                     !  CALL TRANS(N,NCOL,DES,XPR)  FIND THE X PRIME MATRIX
      CALL MATMLT(XPR,DES,XPX,NCOL,N,NCOL,MCOLS,MYRS,MCOLS)  !  FIND THE X PRIME-X MATRIX
      CALL INVERT(NCOL,XPX,XPXINV)                           !  FIND THE X PRIME X INVERSE MATRIX
      WTXPX=XPXINV(2,2)                                      !  SET UP THE WEIGHTING FACTOR FOR THE VARIANCES
      CALL MATMLT(XPR,CNT,XPY,NCOL,N,1,MCOLS,MYRS,1)         !  FIND THE X PRIME Y VECTOR
      CALL MATMLT(XPXINV,XPY,BMAT,NCOL,NCOL,1,MCOLS,MCOLS,1) !  FIND THE B VECTOR (X'X)-1 (X'Y)
      CALL VARCOV(N,NCOL,CNT,XPY,BMAT,XPXINV,COVA)           !  CALL THE SUBROUTINE TO GET THE VAR-COV MATRIX
      CALL MMEANS(N,NCOL,DES,BMAT,MARGM,COVA,VARMAR)

      RETURN
      END
