      SUBROUTINE CALCwtm(SR,N,M,TMAXN,TMINN,TAVEN,TMMN)
      DIMENSION OB(280,6,150)
      real SR(280,4)
      INTEGER N(280,4),M
      COMMON /O/ OB
C
C   PRINT OUT DENSITIES FOR EACH STATE-STRATUM COMBINATION
C   TO FILE 08.  FIRST,CALCULATE THEM
C   SET UP SUMS FOR OVERALL STATE MEANS (TO BE WEIGHTED BY AREAS
C   IN THE ST-STRATA AREAS), THEN DO IT FOR THE WITHIN ST-STRATA AREAS
C
      TMAXN=0.0
      TMAXD=0.0
      TMINN=0.0
      TAVEN=0.0
      TMMN=0.0
c
c  first, calculate the sumsof the weights
c
      wtsum=0.0
      wtsum2=0.0
      do 40 i=1,m
      if(n(i,1).lt.5) go to 40
      sumyrs=0.0
      sumcnts=0.0
      do 35 j=1,n(i,1)
      sumyrs=sumyrs+ob(i,6,j)
      sumcnts=sumcnts+ob(i,2,j)
   35 continue
c  12 July 1996:  Disable these silly criteria
c      if(sumyrs.le.0.0) n(i,1)=0
      if(n(i,1).lt.5) go to 40
c      if((sumcnts/sumyrs).le.0.05) n(i,1)=0
      if(n(i,1).lt.5) go to 40
      wtsum=wtsum+sr(i,2)
      wtsum2=wtsum2+n(i,1)
   40 continue
      DO 180 I=1,M
        SUMMAX=0.0
        SUMMIN=0.0
        SUMAVE=0.0
        SUMMM=0.0
         atot=0.0
        IF(N(I,1).EQ.0)GO TO 180
        DO 170 J=1,N(I,1)
        if(ob(i,4,j).gt.500.0) go to 170
        if(ob(i,4,j).lt.-500.0) go to 170
c
c   ob-4 is the difference:  summax, aumave
c   ob-3 s the marginal mean value
c
          SUMMAX=SUMMAX+OB(I,4,J)
          SUMMIN=SUMMIN+OB(I,3,J)
          SUMAVE=SUMAVE+OB(I,4,J)*OB(I,4,J)
          atot=atot+1.0
c  170     SUMMM=SUMMM+(OB(I,4,J))
  170 continue
        SUMMAX=summax/atot
        summin=summin/atot
        IF(N(I,1).lt.5) GO TO 180
        sumvar=0.0
        DO 270 J=1,N(I,1)
          SUMvar=sumvar+((SUMMAX-OB(I,4,J))**2.0)
  270 continue
C
C  ADD THESE ON TO THE WEIGHTED NUMERATORS AND DENOMINATORS
C  FOR THE WEIGHTED REGIONAL SUMS.
C
        TMP=SR(I,2)
        TMAXD=tmaxd+((tmp/wtsum)**2.0)*((sumvar/(atot-1.0))/atot)
c        TMAXN=TMAXN+TMP*SUMMAX
        TMINN=TMINN+(TMP/wtsum)*SUMMIN
        TAVEN=TAVEN+(TMP/wtsum)*SUMmax
c        TMMN=TMMN+TMP*SUMMM
C
C  TO GET THE BIG LEVEL AVERAGES, SAVE THE ST-STRATA AVERAGES
C  IN THE OB ARRAY SO THEY CAN BE PASSED TO THE BOOTDO, AND
C  HENCE TO THE BIGLIST.
C
        OB(I,4,1)=SUMMAX*TMP
        OB(I,5,1)=SUMMIN*TMP
        OB(I,6,1)=SUMAVE*TMP
        OB(I,4,2)=SR(I,2)
C
C  THESE NEXT LINES CALCULATE ST-STRATA MEANS, AND PRINT THEM
C  OUT TO ANOTHER DATA LINE.  THEY ARE COMMENTED.
C     IF(SR(I,4).EQ. 0.0) GO TO 155
C     AN=SR(I,4)
C     SUMMAX=SUMMAX/AN
C     SUMMIN=SUMMIN/AN
C     SUMAVE=SUMAVE/AN
C 155 WRITE(8,160) ST(I),SR(I,1),SR(I,2),SR(I,4),SUMMAX,SUMMIN,SUMAVE
C 160 FORMAT(4(2X,F8.0),3(2X,F7.3))
C
C   NOW RESET THE VALUES OF THE OB MATRIX IF N(I,1) = 0
C
          OB(I,4,1)=0.0
          OB(I,5,1)=0.0
          OB(I,6,1)=0.0
          OB(I,4,2)=0.0
  180     CONTINUE
C
C  CALCULATE THE REGIONAL WEIGHTED DENSITIES
C
c      IF(TMAXD.EQ.0.0) RETURN
c      TMAXN=TMAXN/TMAXD

      tmaxn=tmaxd
c
      TMmN=taven/tminn
c
cc   change to a %/year (interval 92 to 71)
      tmmn=(((tmmn+1.0)**(1./21.))-1.0)*100.
c
      tminn=wtsum2
c      write(*,*) 'tmmn, taven,tmaxn, tminn',tmmn,taven,tmaxn, tminn
      RETURN
      END
