      SUBROUTINE cutxpx(N,NCOL,DES,WTXPX,cnt) !  THIS SUBROUTINE cutxpx COMES UP WITH a revised estimate of xpx, based on only observers who saw the species

      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION DES(MYRS,MCOLS),cnt(myrs),des2(myrs,mcols),XPR(MCOLS,MYRS),XPX(MCOLS,MCOLS),XPXINV(MCOLS,MCOLS), WTXPX
      integer nbad,badr(myrs),badc(mcols)

c  first, redo the des matrix to get rid of zero counts

c   go through each column by row. if it has all zero counts,
c   go through it again, omitting the rows,
c   then, go through the columns, moving each one over and resetting the column index,

      nn=n
      nncol=ncol
      do i=1,nn
         badr(i)=0
      end do
      nbad=0
      badc(1)=1
      badc(2)=1
      do i=3,nncol
         badc(i)=0
         do j=1,nn                   !   first, identify bad columns.  If badc=1, the column is good
            if(des(j,i).gt.0.9d0) then
               if(cnt(j).gt. log(0.5+.1)) badc(i)=1      
            end if
         end do
         if(badc(i).ne.1) then
            do j=1,nn                 !  now, for the bad columns, identify the bad rows badr=1 is a bad row
               if(des(j,i).gt.0.9d0) then
                 if(cnt(j).le. log(0.5+.1)) badr(j)=1      
               end if
            end do  
         end if
      end do
      ii=0                      !   now "pack" the matrix
      jj=2
      do i=1,nn                 !  pack the rows into des2, if badr=1 it is bad
         if(badr(i).ne.1) then
            ii=ii+1             !  otherwise, increment ii and pack it in
            do j=1,nncol
               des2(ii,j)=des(i,j)
           end do
        end if
      end do

      do j=3,nncol            !  now rows are packed, so pack columns if badc=0 it is bad
         if(badc(j).ne.0) then
            jj=jj+1
            do i=1,ii
               des2(i,jj)=des2(i,j)
            end do
         end if
      end do
      if(nn.eq.ii) return
      nn=ii                   !   Now reset the des matrix
      nncol=jj
      do i=1,nn
        do j=1,nncol      
          des(i,j)=des2(i,j)
        end do
      end do
      XPR=TRANSPOSE(DES)                                        ! CALL TRANS(NN,NNCOL,DES,XPR)  FIND THE X PRIME MATRIX
      CALL MATMLT(XPR,DES,XPX,NNCOL,NN,NNCOL,MCOLS,MYRS,MCOLS)  ! FIND THE X PRIME-X MATRIX
      CALL INVERT(NNCOL,XPX,XPXINV)                             ! FIND THE X PRIME X INVERSE MATRIX
      WTXPX=XPXINV(2,2)                                         ! SET UP THE WEIGHTING FACTOR FOR THE VARIANCES
      RETURN
      END
