      SUBROUTINE GMNEED(MIDYR,N,DES,MARGM,VARMAR,CNT,IFLAG,MSEDF, CMAX,CMIN,SUM)

C  THIS NEXT SUBROUTINE CHECKS TO SEE IF THE ROUTE WAS RUN OVER THE MIDYEAR.  IF IT WAS NOT RUN OVER THE MIDYEAR, THE GM MEAN IS SUBSTITUTED FOR THE MARGINAL MEAN ESTIMATE.

      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION DES(MYRS,MCOLS),MARGM,VARMAR,SUMA,SUMB,CNT(MYRS)
      DOUBLE PRECISION AMAX,AMIN,CMAX,CMIN,SUM
      REAL MIDYR
      AMAX=0  !   FIND MAX YEAR
      AMIN=10000.0
      SUM=0.0
      DO I=1,N
        IF(DES(I,2) .GT. AMAX) THEN
          CMAX=EXP(CNT(I))-0.5
          AMAX=DES(I,2)
        ENDIF
        IF(DES(I,2) .LT. AMIN) THEN
          CMIN=EXP(CNT(I))-0.5
          AMIN=DES(I,2)
        ENDIF
        SUM=SUM+EXP(CNT(I))-0.5
      END DO
      AN=FLOAT(N)
      SUM=SUM/AN

C  THIS NEXT STATEMENT FORCES YOU TO USE THE GM MEAN OF 2-DATA-POINT ROUTES.  SINCE THIS WAS DONE IN SETTWO, RETURN.
      IF(IFLAG .EQ. 2) RETURN

      if(n.lt.6) amax=0.  !   if n<6, use the gmmean
      IF(AMIN.ge.MIDYR .or. AMAX.le.MIDYR) then

         SUMA=0.0  !   IF YOU GET HERE, THE YEARS DO NOT OVERLAP- CALCULATE THE GM MEAM
         SUMB=0.0  !   FIND THE GM MEAN OF CNT + 0.5 
         DO I=1,N
            SUMA=SUMA+CNT(I)
            SUMB=SUMB+CNT(I)*CNT(I)
         END DO
         AN=FLOAT(N)
         MARGM=SUMA/AN
         sumb=0.0
         do i=1,n
            sumb=sumb+(cnt(i)-margm)*(cnt(i)-margm)
         END DO
         VARMAR=(SUMB)/(AN-1.0)
         MSEDF=N-1
      END IF
      RETURN
      END
