
#  PROGRAM TRENDS JANUARY 1990 JRS PRIME FORTRAN 77
rm(list=ls())

     # PARAMETER (MYRS=200,MCOLS=40)

     # INTEGER inbird(1000),IX

#   VARIABLES WITH THE SUFFIX 'NOW' REPRESENT THE CURRENT ROUTE.  THE OTHERS ARE FROM THE ROUTE MOST RECENTLY READ IN.

     # character*25 name,sci*26,regi*3,regi2*3,regi3*10,HEADER*23
     # CHARACTER*80 inbirdF(1000),fin,OBSLIST,tmplst,tmpfn
     # CHARACTER*5 OBSIN

     # REAL STA, YR,RT,STR,HRD,MIDYR,yr1
     # INTEGER RNUM, MFLAG, ALT, ALT2, aou, IAOU, itrim, inde
csc1='c:/csc1'
mypath='c:/csc1/httpd/htdocs/bbs/'; setwd(mypath); library(MASS)
source('c:/csc1/sula/jrs/f8/narte19/slope2.R')
source('c:/csc1/sula/jrs/f8/narte19/readst95.R')
source('c:/csc1/sula/jrs/f8/narte19/readdats.R')
source('c:/csc1/sula/jrs/f8/narte19/setdata.R')
source('c:/csc1/sula/jrs/f8/narte19/allzero.R')
source('c:/csc1/sula/jrs/f8/narte19/analy.R')
source('c:/csc1/sula/jrs/f8/narte19/setcolmn.R')
source('c:/csc1/sula/jrs/f8/narte19/varcov.R')
source('c:/csc1/sula/jrs/f8/narte19/mmeans.R')
source('c:/csc1/sula/jrs/f8/narte19/paultran.R')
source('c:/csc1/sula/jrs/f8/narte19/gmneed.R')
source('c:/csc1/sula/jrs/f8/narte19/indeloif2.R')
source('c:/csc1/sula/jrs/f8/narte19/minwt.R')
source('c:/csc1/sula/jrs/f8/narte19/lois2.R')
source('c:/csc1/sula/jrs/f8/narte19/calclin3.R')
source('c:/csc1/sula/jrs/f8/narte19/supernew.R')
source('c:/csc1/sula/jrs/f8/narte19/cutxpx.R')
source('c:/csc1/sula/jrs/f8/narte19/writslop.R')

      mflag=alt2=inde=itrim=hrd=0
      isuper=ndist=iwt=listsize=1; alt=5
      yr1=iyrf=1966;iyrl=2019;linear=3;noco=5; yr=0
      aou=2940;sta=14;rt=6
      aou=1720; sta=2; rt=1
      
      header='*****'; obsin='.....'

      regi='ALA'  # here, the regions are the state-stratum of interest 
      #call getarg(1,regi3)
      #read(regi3(1:5),'(i5)')aou
      #read(regi3(6:7),'(f2.0)') sta
      #read(regi3(8:10),'(f3.0)') rt
      
      fin=paste0(mypath,'scitab_14all.txt')
      tmpfn=paste0(mypath,'trend/tmp/trendsel.')
      #open(43,file=fin,err=843)  #  here is the read from the scitab file
   #10 read(43,'(6x,i5,6x,a24,6x,a26)',end=400) iaou, name,sci
      a43=readLines(fin); iaou=as.numeric(substr(a43,7,11))
      name=substr(a43,18,41); sci=substr(a43,48,99)
      i=which(aou==iaou); name=name[i]; sci=sci[i]; 
      mflag=1

      ix=as.numeric(Sys.time())  # ix=time()  # ENTER THE INITIAL SEED FOR THE RANDOM NUMBER

      yrf=(iyrf)
      yrl=(iyrl)   

#  now read in the files from 
      inbird=sprintf("%5.5d",iaou[i])

      #OPEN(12,FILE='/csc1/httpd/htdocs/bbs/trend/birdname.95',status='OLD',err=812)  # FILE='/csc1/httpd/htdocs/bbs/trend/birdname.95')
      a12=readLines(paste0(mypath,'trend/birdname.95'))      
      regi2=gsub(' ','1',regi) 
      #if(regi(1:1) == ' ') regi2(1:1)='1'
      #if(regi(2:2) == ' ') regi2(2:2)='1'
      #if(regi(3:3) == ' ') regi2(3:3)='1'

      obslist=paste0(mypath,'trend/regions/',regi2); a19=readLines(obslist)
      #OPEN(19,FILE=obslist,err=819)
      #OPEN(7,FILE='/csc1/httpd/htdocs/bbs/trend/bbszero',err=807)
      
      tmplst=paste(ix) # write(tmplst,*)ix
      midyr = round(yrf + (yrl-yrf+1)/2  )

      cat('<h1>Route Population Change Display</h1>\n')
      if (mflag == 0) {
         cat('No species name found for',aouin,'\n')
      } else {
         cat('<H1>', name,'<EM>',sci,'</EM></H1>\n')
         cat('<H3>Species aou:',aou,'</h3><h3>Region:',sta,rt,'</h3>\n')
         cat('<h3>Trend period:', iyrf,' to ', iyrl,'</h3><pre>\n\n')
         cat('Trend Estimate    P value     N years       Variance    Average Count\n')
   
         for (i in 1:listsize) {   # DO I=1,LISTSIZE

#            NOW CALL THE SLOPE PROGRAM, WHICH WILL CALCULATE THE SLOPES FOR EACH ROUTE OF THIS SPECIES.

             mflag=0
#             open the input for raw data (0,3) or already summarized data (2,4)
            if(alt == 2  ||  alt >= 4) inbirdf=paste0('c:/csc1/bbs2019/databcr19/i',inbird,'.ind')
            if(alt == 0  ||  alt == 2  ||  alt == 3  ||  alt >= 4) 
               suppressWarnings(a9<-readLines(inbirdf)) # OPEN(9,FILE=inbirdf,err=809)

#           REWIND THE AOULIST, SUPERDECK, AND OBSERVER DECK FILES

            #REWIND 12
            #REWIND 19
            itmp=inbird
            if((linear == 2)) itmp=inbird
#           here we open the slopefile and summarized data (index) file.   note that for 2 and 3, you need temp files 
            if(alt == 2  ||  alt == 3  ||  alt >= 4) itmp=9999
   
#           open those puppies- they are either the permanent data set (alt=1,2) or the files to be written to (alt=0,3)
   
            a8=NULL  #OPEN(8,status='SCRATCH',err=808)

#           OPEN A FILE TO READ OUT DATA FOR EACH SPECIES FOR INDEX CALCULATIONS

            cat('<html><HEAD><BODY><H3>Species aou:',aou,'</H3><H3>Region:',sta,rt,'</H3>\n')

#               if alt= 0 or 3 or 4, aou is read in from the data.   here is the first read 
            if(alt == 1  ||  alt == 2  ||  alt == 4  ||  alt == 5) aou=inbird
            i=which(aou==substr(a12,1,5)); aou=substr(a12[i],1,5) #CALL FINDAOU(AOU,HEADER)
            iaou=as.numeric(aou)
            noslopes=0  #  NOSLOPES IS SET EQUAL TO 0, BUT BECOMES 1 WHEN A NON-ZERO SLOPE IS PRINTED

            if(alt != 1) xcall=slope(isuper,linear,ndist,noco,yrf,yrl,midyr,sta,rt,obsin,str,yr,itype,aou,hrd,mflag,noslopes,alt,alt2,yr1)
            stop('asdf')
            #rewind 15  #    ALL SLOPES FOR THIS SPECIES HAVE BEEN CALCULATED, 
            #REWIND 08  #    SO NOW REWIND THE SLOPE FILE, AND CALL THE STATE-LEVEL BOOTSTRAP FILE
            iiif=0
            if((iiif == 0)) xcall=stateval(rnum,alt,isuper,linear)
         }
      }
      