C  PROGRAM TRENDS JANUARY 1990 JRS PRIME FORTRAN 77

      PARAMETER (MYRS=200,MCOLS=40)

      INTEGER INBIRD(1000),IX

C   VARIABLES WITH THE SUFFIX 'NOW' REPRESENT THE CURRENT ROUTE.  THE OTHERS ARE FROM THE ROUTE MOST RECENTLY READ IN.

      character*25 name,sci*26,regi*3,regi2*3,regi3*10,HEADER*23
      CHARACTER*80 INBIRDF(1000),fin,OBSLIST,tmplst,tmpfn
      CHARACTER*5 OBSIN

      REAL STA, YR,RT,STR,HRD,MIDYR,yr1
      INTEGER RNUM, MFLAG, ALT, ALT2, aou, IAOU, itrim, inde

      data mflag,ALT2,INDE,ITRIM/4*0/
      data isuper,NDIST,IWT,listsize/4*1/, ALT/5/
      data yr1,iyrf,iyrl, LINEAR,NOCO/1966,1966,2019,3,5/
      data aou,sta,rt/2940,14,6/

      HEADER='*****'
      OBSIN='.....'

      regi='ALA'  ! here, the regions are the state-stratum of interest 
      call getarg(1,regi3)
      read(regi3(1:5),'(i5)')aou
      read(regi3(6:7),'(f2.0)') sta
      read(regi3(8:10),'(f3.0)') rt
c      print *,aou,sta,rt
      
      fin='/mnt/c/csc1/httpd/htdocs/bbs/scitab_14all.txt'
      tmpfn='/mnt/c/csc1/httpd/htdocs/bbs/trend/tmp/trendsel.'
      open(43,file=fin,err=843)  !  here is the read from the scitab file
   10 read(43,'(6x,i5,6x,a24,6x,a26)',end=400) iaou, name,sci
        if(aou.ne.iaou) go to 10
        mflag=1
  400 continue
      close(43)

      ix=time()  ! ENTER THE INITIAL SEED FOR THE RANDOM NUMBER

      YRF=float(iyrf)
      YRL=float(iyrl)   

c  now read in the files from 
      inbird(1)=aou

      OPEN(12,FILE='/mnt/c/csc1/httpd/htdocs/bbs/trend/birdname.95',status='OLD',err=812)  ! FILE='/mnt/c/csc1/httpd/htdocs/bbs/trend/birdname.95')
      regi2=regi
      if(regi(1:1).eq.' ') regi2(1:1)='1'
      if(regi(2:2).eq.' ') regi2(2:2)='1'
      if(regi(3:3).eq.' ') regi2(3:3)='1'

      obslist='/mnt/c/csc1/httpd/htdocs/bbs/trend/regions/' // regi2 
      OPEN(19,FILE=obslist,err=819)
      OPEN(7,FILE='/mnt/c/csc1/httpd/htdocs/bbs/trend/bbszero',err=807)
      write(tmplst,*)ix
      MIDYR=YRF+(YRL-YRF+1)/2.0

      write(*,'(A)')'<h1>Route Population Change Display</h1>'
      if(mflag.eq.0) then
         write(*,'(A,A)')'No species name found for ',aouin
      else
         write(*,*)'<H1>', name,'<EM>',sci,'</EM></H1>'
         write(*,'(A,I5.5,A,A5,A)')'<H3>Species aou:',aou,'</h3><h3>Region:',regi3(6:10),'</h3>'
         write(*,'(a,i4,a,i4,a)')'<h3>Trend period:', iyrf,' to ', iyrl,'</h3><pre>'
         WRITE(*,'(/a)')'Trend Estimate    P value     N years       Variance    Average Count'
   
         DO I=1,LISTSIZE

C            NOW CALL THE SLOPE PROGRAM, WHICH WILL CALCULATE THE SLOPES FOR EACH ROUTE OF THIS SPECIES.

             MFLAG=0
c             open the input for raw data (0,3) or already summarized data (2,4)
            if(alt.eq.2 .or. alt.ge.4) write(inbirdf(i),'(a,i5.5,a)')'/mnt/c/csc1/bbs2019/databcr19/i', inbird(i),'.ind'
            if(alt.eq.0 .or. alt.eq.2 .or. alt.eq.3 .or. alt.ge.4) OPEN(9,FILE=INBIRDf(I),err=809)

C           REWIND THE AOULIST, SUPERDECK, AND OBSERVER DECK FILES

            REWIND 12
            REWIND 19
            itmp=inbird(i)
            if((linear.eq.2)) itmp=inbird(i)
c           here we open the slopefile and summarized data (index) file.   note that for 2 and 3, you need temp files 
            if(alt.eq.2 .or. alt.eq.3 .or. alt.ge.4) Itmp=9999
   
c           open those puppies- they are either the permanent data set (alt=1,2) or the files to be written to (alt=0,3)
   
            OPEN(8,status='SCRATCH',err=808)

C           OPEN A FILE TO READ OUT DATA FOR EACH SPECIES FOR INDEX CALCULATIONS

            write(*,'(A,i5.5,A,A,A)')'<html><HEAD><BODY><H3>Species aou:',aou,'</H3><H3>Region:',regi3(6:10),'</H3>'

c               if alt= 0 or 3 or 4, aou is read in from the data.   here is the first read 
            if(alt.eq.1 .or. alt.eq.2 .or. alt.eq.4 .or. alt.eq.5) aou=inbird(i)
            CALL FINDAOU(AOU,HEADER)
            IAOU=AOU
            NOSLOPES=0  !  NOSLOPES IS SET EQUAL TO 0, BUT BECOMES 1 WHEN A NON-ZERO SLOPE IS PRINTED
   
            if(alt.ne.1) CALL SLOPE(ISUPER,LINEAR,NDIST,NOCO,YRF,YRL,MIDYR,STA,RT,OBSIN,STR,YR,ITYPE,AOU,HRD,MFLAG,NOSLOPES,ALT,ALT2,yr1)
      
            rewind 15  !    ALL SLOPES FOR THIS SPECIES HAVE BEEN CALCULATED, 
            REWIND 08  !    SO NOW REWIND THE SLOPE FILE, AND CALL THE STATE-LEVEL BOOTSTRAP FILE
            iiif=0
            if((iiif.eq.0)) CALL STATEVAL(RNUM,ALT,isuper,linear)
         END DO
      end if
      STOP
  807 print *,'<p>error opening bbszero</body></html>'
      stop
  808 print *,'<p>error opening scratchfile(unit 8)</body></html>'
      stop
  809 print *,'<p>error opening ',inbirdf(i),'</body></html>'
      stop
  812 print *,'<p>error opening birdname.95</body></html>'
      stop
  819 print *,'<p>error opening ',obslist,'</body></html>'
      stop
  843 print *,'<p>error opening ',fin,'</body></html>'
      stop
      END
