readdats <- function(alt,sta,rt,str,itype,n,xncol,des,yrf,yrl,noco,alt2,yr1){

#  this subroutine prints out the design matrix and counts to an output file for the index analysis  jrs 22 may 1987.

    #parameter (myrs=200,mcols=40)
    #double precision des(myrs,mcols), cnt(myrs)
    #integer rtnow,stanow,strnow,xcat(myrs),n,xncol,nobs,noco, stain,rtin,strin,type(120)
    #integer alt,itype,iend,alt2,strte,lcnt(myrs),in,iobs(myrs)
    #character*5 obs(myrs)
    #real sta,rt,str,yr1,yrf,yrl

    nyrs=(nchar(a9[1])-12)/4  # 2019-1966+1
    if(alt2 == 1) yr1=1955. 
    iend=0   #   write out stata, strata, route to a line then write the design matrix
    iyrf=floor(yrf+0.1)
    iyrl=floor(yrl+0.1)
    izchk = i9=0

    while (izchk != 1) {  #  666
        cnt=des=xcat=iafl=0

        while (iafl ==  0) {  #67 continue
       
            if(alt2 != 1) {                 
                i9=i9+1; if (i9>length(a9)) return(list(iend=1, n=n, xncol=xncol, nobs=nobs, obs=obs, des=des, cnt=cnt))
                stanow=as.numeric(substr(a9[i9],1,2))
                rtnow=as.numeric(substr(a9[i9],3,5))
                strnow=as.numeric(substr(a9[i9],6,8))
                lcnt=unlist(sapply(1:nyrs, function(i) as.numeric(substr(a9[i9],(i-1)*4+13, i*4+12))))
                i9=i9+1; 
                iobs=unlist(sapply(1:nyrs, function(i) as.numeric(substr(a9[i9],(i-1)*4+13, i*4+12))))
                #read(9,'(i2,2i3,4x,100(i4))',   end=50) stanow,rtnow,strnow,(lcnt[i],i=1,nyrs)
                #read(9,'(i2,2i3,4x,100(2x,i2))',end=50) stanow,rtnow,strnow,(iobs[i],i=1,nyrs)
                if(alt != 4  &&  rtnow >= 900) next  #   for route-level analysis, 900 routes should be included##
                istl=stanow*1000+rtnow
                strte=istl
                # special change for hofis: set all observers encountered before observer 1 to 1.
                #  in this way, colonization is adequately incorporated 
                ihofi=0
                if(ihofi != 0) {i=which(iobs==1)[1]; j=which(iobs!=1); iobs[j[j<i]]=1}
            }
            if(alt2 == 1) {  # go to 260
                i9=i9+1; tmp=unlist(strsplit(gsub(' +',',',a9[i9]))) 
                stanow=as.numeric(tmp[1]); rtnow=as.numeric(tmp[2]); xin=as.numeric(tmp[3])
                #read(9,*,end=50) stanow,rtnow,xin  #  this is the cbc input
                i9=i9+1; tmp=unlist(strsplit(gsub(' +',',',a9[i9])))
                type=unlist(sapply(1:xin, function(i) as.numeric(tmp[i])))
                #read(9,*,end=50) (type[i],i=1,xin)
                i9=i9+1; tmp=unlist(strsplit(gsub(' +',',',a9[i9])))
                xcat=unlist(sapply(1:xin, function(i) as.numeric(tmp[i])))
                #read(9,*,end=50) (xcat[i],i=1,xin)
                lcnt=rep(0,nyrs)     
                lcnt[xcat]=type
                
                izzy=0
                #255 read(43,*,end=250) stain,rtin,strin,(type[i],i=1,96) 
                a43=read.table(f43); type[1:45]=type[55+1:45]
                i=which(stanow == stain & rtnow == rtin)
                if (length(i)>0) strnow = strin[i] else {
                    cat('no effort found for' ,stanow,rtnow,'\n')
                    next
                }
            }
            #  now for (the effort adjustment, set to 0s to -1 
            #260 continue

            #  brian sharp analysis:  here is a filter for single route (alt=5) analyses

            if(alt == 5) {  # go to 44
                if(stanow != sta) next
                if(rt > rtnow) next
                if(rt < rtnow) return(list(iend=1, n=n, xncol=xncol, nobs=nobs, obs=obs, des=des, cnt=cnt))
                if(alt2 == 0) cat('<pre>year   count   observer number','\n')
                if(alt2 == 1) cat('<pre>year   count   party hours*10','\n')
                for (ii in 1:nyrs) {
                   if(lcnt[ii] > -1) {
                      if(alt2 == 0) cat(sprintf("%5d   %4d%11d\n",yr1+ii-1,lcnt[ii],iobs[ii]))
                      if(alt2 == 1) cat(sprintf("%5d   %8d%13d\n",yr1+ii-1,lcnt[ii],type[ii]))
                   }  
                }
                if(alt2 == 0) cat('</pre><p>note: observers are numbered sequentially within routes./</html>\n')
            }
            #44 continue

            ipif=0  #  switch for pif analysis 0=off, 1=on
            if(ipif != 0) {  #go to 450
                strnow=izzy=0
                #55 read(43,'(i2,i3,i2)',end=550) stain,rtin,strin
                stain=as.numeric(substr(a43,1,2)); rtin=as.numeric(substr(a32,3,5)); strin=as.numeric(substr(a43,6,7))
                i=which((stanow == stain) & (rtnow == rtin))
                if (length(i)>0) {
                    strnow=strin[i] 
                    if(izzy == 2) {
                        cat( 'no superdeck, abort ',stanow,rtnow,'\n') 
                        next
                    }
                }
                else {
                    if(izzy == 1) izzy=2
                    if(izzy >= 1) {
                        if(izzy == 2) {
                            cat( 'no superdeck, abort ',stanow,rtnow,'\n') 
                            next
                        }
                    } else izzy=1
                }
            }
            #450 continue
            idov=0  #   switch for dove analysis (combining states)
            if(idov != 0) { #go to 755
                if(stanow == 46 || stanow == 21) stanow=98
                if(stanow %in% c(87,58,44,47,18,77)) stanow=97
            }  # 755 continue  

            sta=(stanow);rt=(rtnow); str=(strnow)

            #   this section eliminates new routes 1992 on, to see the effects.   
            #    to put this on, set inewyr=1

            inewyr=0
            if(inewyr == 0) break  # go to 701     
            iafl=(sum(lcnt[1:26] >= 0)>0)                  #   year 26 is 1991

            #  so, iafl = 0 means the route was started after 91 and  
            #     iafl = 1 means the route was run before 92

            #   if this is eq 0, omit the routes started after 91
            #   if this is eq 1, include only the routes started after 91

        }  #  end while(iafl ==  0)  go to 67

        #701 continue
        #  here, eliminate the first counts of each observer  set up a catalogue.  
        #   if not in the catalog, delete and add in
        #  for now, assume that alt =4 implies no first years

        if(alt == 4) {
           nnn=1
           xcat[1]=0
           for (i in 1:nyrs) {
              iif=0
              for (j in 1:nnn) {
                 if(iobs[i] == xcat(j)) iif=iif+1
              }
              if(iif != 1) {
                 nnn=nnn+1; xcat[nnn]=iobs[i]; iobs[i]=0 ; lcnt[i]=-1
              }
           }
        }
       
        #  here is a section to cut out one-time observers.   
        #  switch:  comment this out to ex(#)clude first observers#

        if(alt == 5) {
           nnn=max(iobs)
           for (j in 1:nnn) {
              iif=sum(iobs == j)
              if(iif <= 1) {  
                 for (i in 1:nyrs) {      
                    if(iobs[i] == j) iobs[i]=0      
                    if(iobs[i] == j) lcnt[i]=-1
                 }
              }
           }
        }
        #   first time observers are now cut out
        izchk=n=xncol=0; obs=cnt=des=NULL; nobs=1; if (alt2 == 1) iobs=NULL 
        
        for (i in 1:nyrs) {
           if(lcnt[i] > 0) izchk=1
           iyr=i+floor(yr1+0.1)-1
           if(iyr < iyrf  ||  iyr > iyrl) next
           if(alt2 != 1) {
              if(lcnt[i] <= -1) next
              n=n+1
              obs=c(obs,sprintf("   %2.2d",iobs[i])) # write(obs[n],'(3h   ,i2.2)') iobs[i]
              des=rbind(des,c(1,iyr)); cnt=c(cnt,log(lcnt[i]+0.5))
           }
           else {
              if(type[i] <= 0) next
              n=n+1
              iobs=c(iobs,1); obs=c(obs,'     '); des=rbind(des,c(1,iyr))
              cnt=c(cnt,log((lcnt[i]/type[i]*100)+0.5))
           }
        }

    }  #  end while (izchk != 1) go to 666
    
    if(noco  ==  1) { nobs=1; obs[2:n]='     '} 
    else   nobs=length(unique(obs))
    xncol=nobs+1

    itype=1  #     min wt for non-variance weighted results only ####     
    return(list(iend=0, n=n, xncol=xncol, nobs=nobs, obs=obs, des=des, cnt=cnt))
}