      SUBROUTINE READDATs(ALT,STA,RT,STR,ITYPE,IEND,N,NCOL,DES,CNT,yrf,yrl,obs,nobs,noco,alt2,yr1)

C  THIS SUBROUTINE PRINTS OUT THE DESIGN MATRIX AND COUNTS TO AN OUTPUT FILE FOR THE INDEX ANALYSIS  JRS 22 MAY 1987.

      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION DES(MYRS,MCOLS), CNT(MYRS)
      INTEGER RTNOW,STANOW,STRNOW,cat(myrs),N,NCOL,nobs,noco, STAIN,RTIN,STRiN,TYPE(120)
      INTEGER ALT,ITYPE,IEND,alt2,strte,lcnt(myrs),in,iobs(myrs)
      character*5 obs(myrs)
      REAL STA,RT,STR,yr1,yrf,yrl

      nyrs=2019-1966+1
      if(alt2.eq.1) yr1=1955. 
      iend=0   !   WRITE OUT STATA, STRATA, ROUTE TO A LINE THEN WRITE THE DESIGN MATRIX
      iyrf=int(yrf+0.1)
      iyrl=int(yrl+0.1)
  666 cnt=0
      des=0
      cat=0

   67 continue
     
      if(alt2.ne.1) then
         read(9,'(i2,2i3,4x,100(i4))',   end=50) stanow,rtnow,strnow,(lcnt(i),i=1,nyrs)
         read(9,'(i2,2i3,4x,100(2x,i2))',end=50) stanow,rtnow,strnow,(iobs(i),i=1,nyrs)
         if(alt.ne.4 .and. rtnow.ge.900) go to 67  !   for route-level analysis, 900 routes should be included!!
         istl=stanow*1000+rtnow
         strte=istl
c special change for HOFIs: set all observers encountered before observer 1 to 1.  In this way, colonization is adequately incorporated 

         ihofi=0
         if(ihofi.ne.0) then
            iflag=0
            do i=1,nyrs
               if(lcnt(i).gt.0) then
                  if(iflag.NE.0 .OR. i.LE.25) THEN
                     if(iobs(i).eq.1) iflag=1
                     if(iflag.eq.1) cycle     !  skip to end of loop
                  END IF
                  iobs(i)=1
               end if
            end do
         end if
      end if
      if(alt2.ne.1) go to 260

      read(9,*,end=50) stanow,rtnow,in  !  this is the cbc input
      read(9,*,end=50) (type(i),i=1,in)
      read(9,*,end=50) (cat(i),i=1,in)
      do  i=1,nyrs
         lcnt(i)=0     
      end do
      do i=1,in 
         lcnt(cat(i))=type(i)
      end do
      izzy=0
  255 read(43,*,end=250) STAIN,RTIN,STRin,(TYPE(I),I=1,96) 
      do i=1,45
         type(i)=type(i+55)
      end do
      if(stanow.ne.stain) go to 255
      if(rtnow.ne.rtin) go to 255
      strnow=strin
      go to 251
  250 continue
      write(*,*) 'no effort found for' ,stanow,rtnow
      rewind(43)
      if(izzy.eq.1) izzy=2
      if(izzy.ge.1) go to 251
      izzy=1
      go to 255
  251 continue
      if(izzy.eq.2) write(*,*) 'No effort data, omit rte ',stanow,rtnow 
      if(izzy.eq.2) rewind(43)
      if(izzy.eq.2) go to 67

c  now do the effort adjustment, set to 0s to -1 
  260 continue

c  Brian Sharp analysis:  here is a filter for single route (alt=5) analyses

      if(alt.ne.5) go to 44
      if(stanow.ne.sta) go to 67
      if(rt.gt.rtnow) go to 67
      if(rt.lt.rtnow) go to 50
      if(alt2.eq.0) write(*,*)'<pre>Year   Count   Observer Number'
      if(alt2.eq.1) write(*,*)'<pre>Year   Count   Party Hours*10'
      do ii=1,nyrs
         if(lcnt(ii).gt.-1) then
            if(alt2.eq.0) write(*,'(f5.0,3x,i4,8x,i3)') yr1+(ii-1),lcnt(ii),iobs(ii)
            if(alt2.eq.1) write(*,'(f5.0,3x,i8,8x,i5)') yr1+(ii-1),lcnt(ii),type(ii)
         end if  
      end do
      if(alt2.eq.0) write(*,*)'</pre><P>Note: Observers are numbered sequentially within routes./</html>'
    
   44 continue

      ipif=0  !  switch for pif analysis 0=off, 1=on
      if(ipif.eq.0) go to 450
      strnow=0
       izzy=0
   55 READ(43,'(i2,i3,i2)',END=550) STAIN,RTIN,STRiN
      if(stanow.ne.stain) go to 55
      if(rtnow.ne.rtin) go to 55
      strnow=strin
      go to 551
  550 continue
      rewind(43)
      if(izzy.eq.1) izzy=2
      if(izzy.ge.1) go to 551
      izzy=1
      go to 55
  551 continue
      if(izzy.eq.2) write(*,*) 'No superdeck, abort ',stanow,rtnow 
      if(izzy.eq.2) go to 67
  450 continue
      idov=0  !   switch for dove analysis (combining states)
      if(idov.eq.0) go to 755
      if(stanow.eq.46) stanow=98
      if(stanow.eq.21) stanow=98
      if(stanow.eq.87) stanow=97
      if(stanow.eq.58) stanow=97
      if(stanow.eq.44) stanow=97
      if(stanow.eq.47) stanow=97
      if(stanow.eq.18) stanow=97
      if(stanow.eq.77) stanow=97
  755 continue  

      sta=float(stanow)
      rt=float(rtnow)
      str=float(strnow)

c   this section eliminates new routes 1992 on, to see the effects.   to put this on, set inewyr=1

      inewyr=0
      if(inewyr.eq.0) go to 701     
      iafl=0                         !   year 26 is 1991
      do i=1,26
         if(lcnt(i) .ge.0) iafl=1
      end do
c  so, iafl = 0 means the route was started after 91 and  iafl = 1 means the route was run before 92

c   if this is eq 0, omit the routes started after 91
c   if this is eq 1, include only the routes started after 91

      if(iafl.eq. 0) go to 67

  701 continue
c  here, eliminate the first counts of each observer  set up a catalogue.  if not in the catalog, delete and add in

c  for now, assume that alt =4 implies no first years

      if(alt.eq.4) then
         nnn=1
         cat(1)=0
         do i=1,nyrs
            iif=0
            do j=1,nnn
               if(iobs(i).eq.cat(j)) iif=iif+1
            end do
            if(iif.ne.1) then
               nnn=nnn+1
               cat(nnn)=iobs(i)
               iobs(i)=0      
               lcnt(i)=-1
            end if
         end do
      end if

c  here is a section to cut out one-time observers.   switch:  comment this out to ex(!)clude first observers!

      if(alt.eq.5) then
         nnn=1
         do i=1,nyrs
            if(iobs(i).gt.nnn) nnn=iobs(i)
         end do
         do j=1,nnn
            iif=0
            do i=1,nyrs
               if(iobs(i).eq.j) iif=iif+1
            end do
            if(iif.le.1) then
               do i=1,nyrs      
                  if(iobs(i).eq.j) iobs(i)=0      
                  if(iobs(i).eq.j) lcnt(i)=-1
               end do
            end if
         end do
      end if

      izchk=0                !   first time observers are now cut out
      n=0
      ncol=0
      nobs=1

      do i=1,nyrs
         if(lcnt(i).gt.0) izchk=1
         iyr=i+ifix(yr1+0.1)-1
         if(iyr.lt.iyrf .or. iyr.gt.iyrl) cycle
         if(alt2.ne.1) then
            if(lcnt(i).le.-1) cycle
            n=n+1
            write(obs(n),'(3h   ,i2.2)') iobs(i)
            des(n,2)=float(iyr)
            des(n,1)=1.0d0
            cnt(n)=log(float(lcnt(i))+0.5d0)
         else
            if(type(i).le.0) cycle
            n=n+1
            iobs(n)=1
            obs(n)='     '
            des(n,2)=float(iyr)
            des(n,1)=1.0d0
            cnt(n)=log((float(lcnt(i))/(float(type(i)))*100.0d0)+0.5d0)
         end if
      end do

      if(izchk.ne.1) go to 666

      DO I=2,N               !   find the number of columns
        IF(NOCO .EQ. 1) THEN
           OBS(I)='     '
        ELSE
          IFLAG=1
          DO J=1,I-1
            IF(OBS(I).EQ.OBS(J))IFLAG=0
          END DO
          IF(IFLAG.eq.1) NOBS=NOBS+1
        ENDIF
      END DO
      ncol=nobs+1

      ITYPE=1  !     min wt for non-variance weighted results only !!!!
      IF(NOCO .EQ. 1) nobs=1      
      return
   50 IEND=1
      RETURN
      END
