      SUBROUTINE VARCOV(N,NCOL,CNT,XPY,BMAT,XPXINV,COVA) !  THIS SUBROUTINE CALCULATES THE VAR-COVAR MATRIX

      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION CNT(MYRS),XPY(MYRS),BMAT(MYRS),MSE,XPXINV(MCOLS,MCOLS),COVA(MCOLS,MCOLS),SUM,SUM2

      SUM=0.0        !    FIRST FIND Y'Y
      DO I=1,N
         SUM=SUM+CNT(I)*CNT(I)
      end do
      SUM2=0.0
      DO I=1,NCOL
        SUM2=SUM2+BMAT(I)*XPY(I)
      END DO
      MSE=(SUM-SUM2)/FLOAT(N-NCOL)
      DO I=1,NCOL
        DO J=1,NCOL
          COVA(J,I)=MSE*XPXINV(J,I)
        END DO
      END DO
      RETURN
      END
