      SUBROUTINE CALCMEAN(SR,N,M,TMAXN,TMINN,TAVEN,TMMN)
      DIMENSION OB(280,6,150)
      real SR(280,4)
      INTEGER N(280,4),M
      COMMON /O/ OB

C   PRINT OUT DENSITIES FOR EACH STATE-STRATUM COMBINATION TO FILE 08.  FIRST,CALCULATE THEM SET UP SUMS FOR OVERALL STATE MEANS (TO BE WEIGHTED BY AREAS
C   IN THE ST-STRATA AREAS), THEN DO IT FOR THE WITHIN ST-STRATA AREAS

      TMAXN=0.0
      TMAXD=0.0
      TMINN=0.0
      TAVEN=0.0
      TMMN=0.0
      DO I=1,M
         SUMMAX=0.0
         SUMMIN=0.0
         SUMAVE=0.0
         SUMMM=0.0
         IF(N(I,1).NE.0) THEN
         DO J=1,N(I,1)
            SUMMAX=SUMMAX+OB(I,4,J)
            SUMMIN=SUMMIN+OB(I,5,J)
            SUMAVE=SUMAVE+OB(I,6,J)
            SUMMM=SUMMM+(OB(I,3,J))
        END DO
        TMP=SR(I,2)/SR(I,4)  !   ADD THESE ON TO THE WEIGHTED NUMERATORS AND DENOMINATORS FOR THE WEIGHTED REGIONAL SUMS.
        TMAXD=TMAXD+SR(I,2)
        TMAXN=TMAXN+TMP*SUMMAX
        TMINN=TMINN+TMP*SUMMIN
        TAVEN=TAVEN+TMP*SUMAVE
        TMMN=TMMN+TMP*SUMMM
        OB(I,4,1)=SUMMAX*TMP   !  TO GET THE BIG LEVEL AVERAGES, SAVE THE ST-STRATA AVERAGES IN THE OB ARRAY SO
        OB(I,5,1)=SUMMIN*TMP   !   THEY CAN BE PASSED TO THE BOOTDO, AND HENCE TO THE BIGLIST.
        OB(I,6,1)=SUMAVE*TMP
        OB(I,4,2)=SR(I,2)
        OB(I,4,1)=0.0  !   NOW RESET THE VALUES OF THE OB MATRIX IF N(I,1) = 0
        OB(I,5,1)=0.0
        OB(I,6,1)=0.0
        OB(I,4,2)=0.0
        END IF
      END DO

      IF(TMAXD.NE.0.0) THEN
         TMAXN=TMAXN/TMAXD  !   CALCULATE THE REGIONAL WEIGHTED DENSITIES
         TMINN=TMINN/TMAXD
         TAVEN=TAVEN/TMAXD
         TMMN=TMMN/TMAXD
      END IF
      RETURN
      END
