cutxpx <- function(n,ncol,des,wtxpx,cnt) { # this comes up with a revised estimate of xpx, based on only observers who saw the species

      #  first, redo the des matrix to get rid of zero counts

      #   go through each column by row. if it has all zero counts,
      #   go through it again, omitting the rows,
      #   {, go through the columns, moving each one over and resetting the column index,

      nn=n; nncol=ncol; badr=rep(0,nn); nbad=0; badc=rep(0,nncol)
      badc[1:2]=1
      for (i in 3:nncol) {
         for (j in 1:nn) {       #first, identify bad columns.  if badc=1, the column is good
            if(des[j,i] > 0.9) {
               if(cnt[j] > log(0.5+.1)) badc[i]=1      
            }
         }
         if(badc[i] != 1) {
            for (j in 1:nn) {                 #  now, for the bad columns, identify the bad rows badr=1 is a bad row
               if(des[j,i] > 0.9) {
                 if(cnt[j] <=  log(0.5+.1)) badr[j]=1      
               }
            }  
         }
      }
      ii=0; jj=2; des2=des-des          #   now "pack" the matrix
      for (i in 1:nn) {                 #  pack the rows into des2, if badr=1 it is bad
         if(badr[i] != 1) {
            ii=ii+1; des2[ii,1:nncol]=des[i,1:nncol] #  otherwise, increment ii and pack it in 
         }
      }

      for (j in 3:nncol) {            #  now rows are packed, so pack columns if badc=0 it is bad
         if(badc[j] != 0) {
            jj=jj+1; des2[1:ii,jj]=des2[1:ii,j]
         }
      }
      if(nn == ii) return
      nn=ii; nncol=jj            #   now reset the des matrix
      des[1:nn, 1:nncol] = des2[1:nn, 1:nncol]

      xpr=t(des)                                        # call trans(nn,nncol,des,xpr)  find the x prime matrix
      xpx = xpr %*% des    # find the x prime-x matrix
      xpxinv = solve(xpx)  # find the x prime x inverse matrix
      wtxpx=xpxinv[2,2]                                         # set up the weighting factor for the variances
      return(xpxinv[2,2])
}
