gmneed <- function(midyr,n,des,margm,varmar,cnt,iflag,msedf){

#  this checks to see if the route was run over the midyear.  
#    if it was not run over the midyear, the gm mean is substituted 
#    for the marginal mean estimate.

    i=which.min(des[,2]); j=which.max(des[,2]) #   find max year
    amin=des[i,2]; amax=des[j,2]
    cmin=exp(cnt[i])-.5; cmax=exp(cnt[j])-.5
    xsum=mean(exp(cnt[1:n])-.5)

#  this next statement forces you to use the gm mean of 2-data-point routes.  since this was done in settwo, return.
    if(iflag  ==  2) return(list(margm=margm, varmar=varmar, msedf=msedf, cmin=cmin, cmax=cmax, xsum=xsum))

    if(n < 6) amax=0  #   if n<6, use the gmmean
    if(amin >= midyr  ||  amax <= midyr) {

       #   if you get here, the years do not overlap- calculate the gm meam
       #   find the gm mean of cnt + 0.5 

       margm=mean(cnt[1:n])
       xsumb=sum(cnt[1:n]-margm)^2
       varmar=(xsumb)/(n-1)
       msedf=n-1
    }
    return(list(margm=margm, varmar=varmar, msedf=msedf, cmin=cmin, cmax=cmax, xsum=xsum))
}
