mmeans <- function(n,ncol,des,bmat,cova) { # this calculates marginal means and variances( called from analy )

    obs=1/(ncol-1)             #  find average of the observer levels
    tot=mean(des[,2])          #             find average of the years
    margm=bmat[1]+bmat[2]*tot  #    calculate marginal mean
    expval=c(1,tot,rep(obs,ncol-2))
    margm=margm+sum(bmat[3:ncol]*obs)
    dumm=cova %*% expval               #   find (x'x)-1*x
    varmar=sum(expval[1:ncol]*dumm[1:ncol])    #  now find x'(x'x)-1*x

    return(list(margm=margm, varmar=varmar))
}
