      SUBROUTINE MMEANS(N,NCOL,DES,BMAT,MARGM,COVA,VARMAR)  !  THIS SUBROUTINE CALCULATES MARGINAL MEANS AND VARIANCES( CALLED FROM ANALY )

      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION DES(MYRS,MCOLS),BMAT(MYRS),COVA(MCOLS,MCOLS),EXPVAL(MYRS), DUMM(MYRS),MARGM,VARMAR,TOT,OBS

      OBS=1.0/FLOAT(NCOL-1)  !             FIND AVERAGE OF THE OBSERVER LEVELS
      TOT=0.0                !             FIND AVERAGE OF THE YEARS
      DO I=1,N
        TOT=TOT+DES(I,2)
      END DO
      TOT=TOT/FLOAT(N)
      MARGM=BMAT(1)+BMAT(2)*TOT  !    CALCULATE MARGINAL MEAN
      DO I=3,NCOL                !    NOW ADD ON THE OBSERVER EFFECTS & SET UP VECTOR OF X(I)'S
        EXPVAL(I)=OBS
        MARGM=MARGM+(BMAT(I)*OBS)
      END DO
      EXPVAL(1)=1.0
      EXPVAL(2)=TOT
      CALL MATMLT(COVA,EXPVAL,DUMM,NCOL,NCOL,1,MCOLS,MCOLS,1)   !   FIND (X'X)-1*X
      VARMAR=0.0                                                !  NOW FIND X'(X'X)-1*X
      DO I=1,NCOL
        VARMAR=VARMAR+EXPVAL(I)*DUMM(I)
      END DO
      RETURN
      END
