      SUBROUTINE READSTSR(M,ST,SR,N,ALT,isuper,linear)
      REAL OB(280,6,150),SR(280,4),lcnt(55),amin,early,late
      REAL STATE,STRATA,SLOPE,XPXINV,MMEAN,CMAX,CMIN,SUM,ST(280),rte
      INTEGER N(280,4),M,ALT,isuper,linear,numfin
      character*8 ctmp(55),cfin*5,slopec*14,xpxinvc*14,mmeanc*14
      character*3 starch,cnum
      COMMON /O/OB
      ic=1
      print *,'readstsr'

   50 continue
      
      if(linear.eq.2) go to 105

      If((linear.ne.2).and.(alt.eq.5))read(8,55,END=100)STATE,rte,STRATA,SLOPEc,XPXINVc,MMEANc,SUM,nyr,cmin
      If((linear.ne.2).and.(alt.ne.5))read(8,55,END=100)STATE,rte,STRATA,SLOPEc,XPXINVc,MMEANc,SUM,nyr
      If(linear.ne.2) print *,8,STATE,rte,STRATA,SLOPEc,XPXINVc,MMEANc,SUM,nyr
   55 FORMAT(1X,F6.0,1X,f5.0,1x,F4.0,3a14,1X,F9.2,1x,i5,f14.8)
       if(slopec.eq.'**************') go to 50
       if(slopec.eq.'           NaN') go to 50
       if(slopec.eq.'           nan') go to 50
       if(xpxinvc.eq.'**************') go to 50
       if(xpxinvc.eq.'           NaN') go to 50
       if(xpxinvc.eq.'           nan') go to 50
       if(xpxinvc.eq.'      Infinity') go to 50
       if(mmeanc.eq.'**************') go to 50
       if(mmeanc.eq.'           NaN') go to 50
       if(mmeanc.eq.'           nan') go to 50
       if(mmeanc.eq.'      Infinity') go to 50
       read(slopec,'(f14.8)') slope
       read(mmeanc,'(f14.6)') mmean
       read(xpxinvc,'(f14.8)') xpxinv

  105 if(linear.ne.2) go to 110
      ic=ic+1

      read(8,'(3f5.0,a3,1x,15x,a5)',end=100) STATE,rte,STRATA,cnum,cfin
      if(cnum.eq.'***') go to 50
      read(cnum,'(i3)') numfin  !   n yrs=numfin, amin=first yr 
      if(cfin.eq.'*****') go to 50
      read(cfin,'(f5.0)') amin
      if(linear.eq.2) read(8,'(3f5.0,50a8)',end=100) STATE,rte,STRATA,(ctmp(i),i=1,numfin)
      iflag=0
      do i=1,numfin
         if(ctmp(i).eq.'********') iflag=1
         if(iflag.ne.1)read(ctmp(i), '(f8.3)') lcnt(i)
      end do
      if(iflag.eq.1) go to 50

c  here is a section to process the loess data. dump all-zero routes
      izip=0
      early=0.0
      aea=0.0
      late=0.0
      ale=0.0
      do i=1,numfin
         if(lcnt(i).gt.0.0) izip=1
         if((ifix(amin)+(i-1)).eq.1970) early=early+lcnt(i)  !   year is amin+(i-1):  i=1 implies yr=amin
         if((ifix(amin)+(i-1)).eq.1971) early=early+lcnt(i)      
         if((ifix(amin)+(i-1)).eq.1972) early=early+lcnt(i)      
         if((ifix(amin)+(i-1)).eq.1992) late=late+lcnt(i)      
         if((ifix(amin)+(i-1)).eq.1993) late=late+lcnt(i)      
         if((ifix(amin)+(i-1)).eq.1994) late=late+lcnt(i)      
         if((ifix(amin)+(i-1)).eq.1970) aea=aea+1.0
         if((ifix(amin)+(i-1)).eq.1971) aea=aea+1.0
         if((ifix(amin)+(i-1)).eq.1972) aea=aea+1.0
         if((ifix(amin)+(i-1)).eq.1992) ale=ale+1.0
         if((ifix(amin)+(i-1)).eq.1993) ale=ale+1.0
         if((ifix(amin)+(i-1)).eq.1994) ale=ale+1.0
      end do
      if(izip.eq.0) go to 50

c  find "early" and "late".  early= lcnt 70-72  late= lcnt 91-93.   Note Change above ***** 92-94, not 91-93!

        if(aea.gt.0.0) early=early/aea
        if(ale.gt.0.0) late=late/ale
        imid=ifix(amin+(float(numfin)/2.0))
c        write(*,*) 'state, rte, early, late',state, rte, early, late
      DO I=1,M
         IF(ifix(STATE+.1) .EQ. ifix(ST(I)+.1) .AND. ifix(STRATA+.1) .EQ. ifix(SR(I,1)+.1)) THEN
            n(i,1)=n(i,1)+1
            OB(I,4,N(I,1))=late-early
            OB(I,3,N(I,1))=early
         END IF
      END DO
      go to 50

  110 if(alt.EQ.5) THEN
         cmin=cmin*100.
         slope=(slope-1.0)*100.
         xpxinv=slope/(cmin)
         aprob=2.0*tprob(10000.,abs(xpxinv))
         if(xpxinv.lt.0.0) xpxinv=-xpxinv
         starch='   '
         if(xpxinv.gt.2.52) starch='***'
         if(xpxinv.gt.1.96) starch=' **'
         if(xpxinv.gt.1.64) starch='  *'
         itot=nyr
         idf=1
         write(*,578) slope,aprob,itot,cmin,sum
  578    FORMAT('EEQ:    ',F6.2,3x,f8.5,4X,I4,5x,1X,F11.4,7x,F8.2)
         write(*,*) '<p>Warning: single site analysis - variance may not be valid !<P>'
         if(sum.lt.0.5) write(*,*) 'Warning: low relative abundance species - view results with caution!<P>'
         RETURN
      end if

      cmax=sum  !  recode the strata.  if the strata-wide trends are of interest , 
      cmin=sum  !  state=1.  state-strata trends  1 July 1995
      iflag=0
      DO I=1,M
        IF(ifix(STATE+.1) .EQ. ifix(ST(I)+.1) .AND. ifix(STRATA+.1) .EQ. ifix(SR(I,1)+.1)) THEN
           IF((SLOPE .GT. 0.00001).AND.(MMEAN.Ge.0.001)) N(I,1)=N(I,1)+1
           IF((SLOPE .LE..0001).AND.(MMEAN.lE.0.001)) N(I,2)=N(I,2)+1
           IF(SLOPE .GT. 1.0) N(I,3)=N(I,3)+1
           IF((SLOPE .GT. 0.0).AND.(SLOPE.LT.1.0)) N(I,4)=N(I,4)+1
           NHOLD=N(I,1)+N(I,2)  !   STORE THE UNIT AND HUNTING STATUS
           IF(isuper.ne.1) SR(I,4)=float(nhold)
           IF(SLOPE .GT..0001 .OR. MMEAN.GT..0001) THEN
              OB(I,1,N(I,1))=SLOPE  !   the real low abundance routes are included this year
              OB(I,2,N(I,1))=XPXINV
              OB(I,3,N(I,1))=MMEAN
              OB(I,4,N(I,1))=CMAX
              OB(I,5,N(I,1))=CMIN
              OB(I,6,N(I,1))=SUM
              iflag=1
           END IF
        END IF
      END DO
      GO TO 50
  100 RETURN
      END




