slope <- function(isuper,linear,ndist,noco,yrf,yrl,midyr, sta,rt,obsin,str,yr,itype,aou,hrd,mflag,noslopes,alt,alt2,yr1)

#   THIS TREND ANALYSIS PROGRAM READS IN DATA FOR EACH ROUTE,  CALCULATES A LINEAR ESTIMATE OF TREND ON LN(COUNT+0.5)
#   WITH OBSERVER AS A COVARIABLE, THEN PRINTS OUT THE ESTIMATE  OF THE TREND ALONG WITH ACCESSORY DATA FOR EACH ROUTE.   JOHN SAUER, OMBM, 22 APRIL 1986

    #  PARAMETER (MYRS=200,MCOLS=40)
    #  DOUBLE PRECISION DES(MYRS,MCOLS), CNT(MYRS), BMAT(MYRS), COVA(MCOLS,MCOLS),bluesm,wtm,blink,VARMAR, MARGM, WTXPX,BACKM,BLUES, DIST(MYRS),CMAX,CMIN,SUM,blvar
    #  INTEGER ALT, N,NOBS,NCOL,IFLAG,I,ALT2,  ITYPE,AOU,AOUIN,MFLAG
    #  CHARACTER*5 OBS(MYRS), OBSIN                                   #  VARIABLES WITH THE SUFFIX 'NOW' REPRESENT THE CURRENT ROUTE.
    #  REAL STA, STANOW, YR,RT,STR,HRD,ANG,yr1, RTNOW,STRNOW,MIDYR    #   THE OTHERS ARE FROM THE ROUTE MOST RECENTLY READ IN.  

#  imnwt is a temporary flag to allow check of minimum sample wts. 2 means that min sample wt is checked
     imnwt=0
     des=matrix(1, myrs,mcols) #  SET UP THE FIRST COLUMN TO BE ONES


#  IF FIRST TIME THROUGH, SKIP FIRST READ (USE VALUES FROM MAIN PROGRAM)
#  PUT THESE IN HERE SO THAT IF 1 ROUTE EXISTS FOR  THE SPP AND IT HAS AN IMPROPER TYPE, THE PROGRAM DOESN'T BOMB

      n=0; nobs=1; aouin=aou; rtnow=rt; stanow=sta
      if(isuper != 1) strnow=str
      if(alt != 2) { 
		iflag=0  #  (44)  IF NO COVARIABLE, SET OBSERVER=NUN
        xcall=missing(yr,yrf,yrl,sta,rt,hrd,iflag,alt,isuper) # IF NO COVARIABLE, SET OBSERVER=NUN
        if (iflag != 1) {
		  n=0; nobs=1  #  NO MISSING DATA, SO STORE IT IN DATA ARRAYS
          xcall=setdata(n,yr,obsin,hrd,obs,des,cnt,linear,dst,dist,ndist,isuper)
          rtnow=rt; stanow=sta
          if(isuper != 1) strnow=str
		}
      }
   # 30 continue
   #50 continue
     x543=x1000=0
     while (1) {
		  if((alt == 2) || (alt >= 4)) xcall=readdats(alt,stanow,rtnow,strnow,itype,iend,n,ncol,des,cnt,yrf,yrl,obs,nobs,noco,alt2,yr1)
		  if(iend == 1) { mflag=1; iend=0; return()}
		  if((alt == 2) || (alt >= 4)) { x543=1; break } #go to 543
		  if(aou  !=  aouin) { x1000=1; break } #  go to 1000 #  IF NEW SPECIES, ANALYZE LAST ROUTE, THEN EXIT
		  iflag=0
	          #   IF NO OBSERVER COVARIABLE SET OBSERVER TO NUN
		  xcall=missing(yr,yrf,yrl,sta,rt,hrd,iflag,alt,isuper)
		  if(iflag  ==  1) next  # go to 50
		  if((rt  !=  rtnow) || (sta  !=  stanow)) break  # go to 500
		  xcall=setdata(n,yr,obsin,hrd,obs,des,cnt,linear,dst,dist,ndist,isuper)
	}  #  go to 50

  #500 CONTINUE
     if (x543==0 && x1000==0) {  # we didn't break out of loop at alt==2 || alt>=4 or aou!=aouin
#  NOW HERE IS THE ANALYSIS,  NOW xcall=IN SUPERDECK: IT WILL ADD IN ZERO ROUTES.
      if(alt != 9) xcall=super(rtnow,stanow,n,nobs,des,cnt,obs,strnow,noco,yrf,yrl,isuper)
     }
#  CHECK FOR ALL ZERO ROUTES
     if (x1000==0) {  #  we didn't break out of loop at aou!=aouin
  #543 continue
      xcall=allzero(stanow,rtnow,n,nobs,cnt,iflag,linear,ndist, strnow,alt)
      if(iflag  ==  1) { # go to 600
        rtnow=rt; stanow=sta; 
	    if(isuper != 1) strnow=str
        n=0; nobs=1
        xcall=setdata(n,nobs,yr,obsin,hrd,obs,des,cnt,linear,dst,dist,ndist,isuper)
        go to 50	  
	  }

#  xcall=THE ANALYSIS. DONT LET THE ROUTES WITH N=2 GO IN TO ANALY

      if(((iflag == 3) && (linear == 3)) || (linear == 2)) xcall=setcolmn(nobs,n,ncol,des,obs)
      if(iflag == 3) iflag=2
      if(iflag  !=  2) {  #  go to 550
        if(linear != 2) {  # go to 620
        xcall=analy(nobs,n,ncol,des,obs,cnt,bmat,cova,margm,varmar, wtxpx)

#   xcall=THE BACK-TRANSFORMATION SUBROUTINE FOR THE SLOPE

        msedf=n-ncol
        if(linear != 1) xcall=paultran(msedf,bmat[2],cova[2,2],blues)
        } # 550 
	  }
	  if (linear != 2 || iflag==2) {
		  if(iflag  ==  2) xcall=settwo(n,nobs,des,bmat[2],cova[2,2], msedf,margm,varmar,cnt,wtxpx,obs)
		  if(linear ==  1) blues=bmat[2]
		  if((iflag == 2) && (linear != 1)) blues=exp(bmat[2])
		  xcall=gmneed(midyr,n,des,margm,varmar,cnt,iflag,msedf, cmax,cmin,sum)  #   now xcall=the subroutine to back transform the marginal mean.

	#  I HAVE LEFT THE DF=N-NCOL REGARDLESS OF WHICH MEAN IS USED#

		  if((linear != 1) && (iflag != 2))  xcall=paultran(msedf,margm,varmar,backm)
		  if(linear  ==  1) backm=margm
		  if(iflag  ==  2) backm=exp(margm)
		  if(linear  !=  1) backm=backm-0.5
		  if((backm.le.0.0) && (iflag != 2)) backm=0.001  #  roundoff error could make the back-transformed mmean < 0,  so if it is negative, make it a small positive value.

		  if((blues > 0.0) || (backm > 0.0) || (wtxpx > 0.0)) noslopes=1  #  if slope  exists, set noslopes to 1
		  malt=1
     }
  #620   #   Here is the lowess subroutine
      if((linear ==  2) || (alt == 5)) xcall=indelois(n,ncol,rtnow,stanow,strnow,des,cnt,aouin,yrf,yrl,blues,backm,sum,alt) #   Here is the lowess subroutine
      if(blues >= -9990) { # go to 345
		  myr=floor(min(des[,2]))
		  msedf=n-ncol
	#    here is a version that prints out a variance      jrs 11 May 1994.   this is a variance based on the bradu-mundlac stuff

		  wtm=(blues/exp(bmat[2]))*exp(2.0*bmat[2])*cova[2,2]*10000.
	#  this doesn't work for routes with only 1 nonzero count or with 2-year trends.  do not print these

		  ast=stanow*1000+rtnow
		  bluesm=(blues-1.0)*100
		  if(imnwt ==  2) xcall=minwt(n,ncol,des,cnt,yrf,cmin)

		  iflag=0  #   here is the xcall=the the estimating equation approach 15 june 1994
		  if(linear == 3) xcall=calclink(stanow,rtnow,N,NCOL,DES,CNT,YRF,Blink,iflag,blues,blvar)
	#  if iflag = 0, skip writert
		  if(linear == 3) blues=blink
		  if(linear == 3) xcall=cutxpx(n,ncol,des,wtxpx,cnt)
		  if(linear == 3) cova[2,2]=blvar
		  if(!(linear == 2 || ((linear == 3) && (iflag == 0)))) 
			 xcall=writert(rtnow,stanow,strnow,cova,blues, varmar,backm,wtxpx,cmax,cmin,sum,n,aou,alt)
	  }
  #345 continue
    }  #  end of if (x1000==0)
# REMEMBER TO RESET THE ROUTE
 #1000 continue

#  NOW ANALYZE THE LAST GROUP.  NOW xcall=IN SUPERDECK: IT WILL ADD IN ZERO ROUTES.

      if(alt != 9) xcall=super(rtnow,stanow,n,nobs,des,cnt,obs,strnow,noco,yrf,yrl,isuper)

#  CHECK FOR ALL ZERO ROUTES

      xcall=allzero(stanow,rtnow,n,nobs,cnt,iflag,linear,ndist, strnow,alt)
      if(iflag  ==  1) return

      if(((iflag == 3) && (linear == 3)) || (linear == 2)) xcall=setcolmn(nobs,n,ncol,des,obs)
      if(iflag  ==  3) iflag=2
      if(iflag  ==  2) {  # go to 750
	    if(iflag  ==  2) xcall=settwo(n,nobs,des,bmat[2],cova[2,2], msedf,margm,varmar,cnt,wtxpx,obs)
		if(linear  ==  1) blues=bmat[2]
		if((iflag == 2) && (linear != 1)) blues=exp(bmat[2])

	#            NOW xcall=THE SUBROUTINE TO BACK TRANSFORM THE MARGINAL MEAN.
		xcall=gmneed(midyr,n,des,margm,varmar,cnt,iflag,msedf,cmax,cmin,sum)
		if((linear !=  1) && (iflag != 2)) xcall=paultran(msedf,margm,varmar,backm)
		if(linear  ==  1) backm=margm
		if(iflag  ==  2) backm=exp(margm)
		if(linear  !=  1) backm=backm-0.5

	#  ROUNDOFF ERROR COULD MAKE THE BACK-TRANSFORMED MMEAN < 0,  SO IF NEGATIVE, MAKE IT A SMALL POSITIVE  if 2 years, let it be 0
		if((backm.le.0.0) && (iflag != 2)) backm=0.001 
		if((blues > 0.0) || (backm > 0.0) || (wtxpx > 0.0)) noslopes=1
		malt=1
        if((linear ==  2) || (alt == 5)) xcall=indelois(n,ncol,rtnow,stanow,strnow,des,cnt,aouin,yrf,yrl,blues,backm,sum,alt)  #   here is the lowess subroutine
        if(blues < -9990) return(0)
        myr=1000; myr=min(floor(des[,2]))
        msedf=n-ncol

#    here is a version that prints out a variance       jrs 11 may 1994.   this is a variance based on the bradu-mundlac stuff

        wtm=(blues/exp(bmat[2]))*exp(2.0*bmat[2])*cova[2,2]*10000.0
        ast=stanow*1000+rtnow
        bluesm=(blues-1.0)*100.0

        if(imnwt ==  2) xcall=minwt(n,ncol,des,cnt,yrf,cmin)
        iflag=0                #   here is the xcall=the the estimating equation approach 15 june 1994
        if(linear == 3) xcall=calclink(stanow,rtnow,n,ncol,des,cnt,yrf,blink,iflag,blues,blvar)
        if(linear == 3) blues=blink
        if(linear == 3) cova[2,2]=blvar
        if(linear == 3) xcall=cutxpx(n,ncol,des,wtxpx,cnt)
#         if iflag = 0, skip writert
        if(linear == 2) return(0)
        if((linear == 3) && (iflag == 0)) return(0)
        xcall=writert(rtnow,stanow,strnow,cova,ang,blues, varmar,backm,wtxpx,cmax,cmin,sum,n,aouin,alt)
        return(0)	  
	  }

#  xcall=THE ANALYSIS

      if(linear != 2) { # go to 640
		  xcall=analy(nobs,n,ncol,des,obs,cnt,bmat,cova,margm,varmar, wtxpx)
		  msedf=n-ncol            #   xcall=the back-transformation subroutine for the slope
		  if(linear != 1) xcall=paultran(msedf,bmat[2],cova[2,2],blues)
	  #750
    	  if(iflag  ==  2) xcall=settwo(n,nobs,des,bmat[2],cova[2,2], msedf,margm,varmar,cnt,wtxpx,obs)
		  if(linear  ==  1) blues=bmat[2]
		  if((iflag == 2) && (linear != 1)) blues=exp(bmat[2])

	#            NOW xcall=THE SUBROUTINE TO BACK TRANSFORM THE MARGINAL MEAN.
		  xcall=gmneed(midyr,n,des,margm,varmar,cnt,iflag,msedf,cmax,cmin,sum)
		  if((linear !=  1) && (iflag != 2)) xcall=paultran(msedf,margm,varmar,backm)
		  if(linear  ==  1) backm=margm
		  if(iflag  ==  2) backm=exp(margm)
		  if(linear  !=  1) backm=backm-0.5

	#  ROUNDOFF ERROR COULD MAKE THE BACK-TRANSFORMED MMEAN < 0,  SO IF NEGATIVE, MAKE IT A SMALL POSITIVE  if 2 years, let it be 0
		  if((backm.le.0.0) && (iflag != 2)) backm=0.001 
		  if((blues > 0.0) || (backm > 0.0) || (wtxpx > 0.0)) noslopes=1
		  malt=1
	  }
  #640 
      if((linear ==  2) || (alt == 5)) xcall=indelois(n,ncol,rtnow,stanow,strnow,des,cnt,aouin,yrf,yrl,blues,backm,sum,alt)  #   here is the lowess subroutine
      if(blues < -9990) return(0)
      myr=1000; myr=min(floor(des[,2]))
      msedf=n-ncol

#    here is a version that prints out a variance       jrs 11 may 1994.   this is a variance based on the bradu-mundlac stuff

      wtm=(blues/exp(bmat[2]))*exp(2.0*bmat[2])*cova[2,2]*10000.0
      ast=stanow*1000+rtnow
      bluesm=(blues-1.0)*100.0

      if(imnwt ==  2) xcall=minwt(n,ncol,des,cnt,yrf,cmin)
      iflag=0                #   here is the xcall=the the estimating equation approach 15 june 1994
      if(linear == 3) xcall=calclink(stanow,rtnow,n,ncol,des,cnt,yrf,blink,iflag,blues,blvar)
      if(linear == 3) blues=blink
      if(linear == 3) cova[2,2]=blvar
      if(linear == 3) xcall=cutxpx(n,ncol,des,wtxpx,cnt)
#         if iflag = 0, skip writert
      if(linear == 2) return(0)
      if((linear == 3) && (iflag == 0)) return(0)
      xcall=writert(rtnow,stanow,strnow,cova,ang,blues, varmar,backm,wtxpx,cmax,cmin,sum,n,aouin,alt)
      return(0)

### 

